<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>User Registration</title>
</head>
<body>
    <h2>User Registration Form</h2>
    <form action="<?php echo htmlspecialchars($_SERVER['PHP_SELF']); ?>" method="POST">
        
        <input type="hidden" name="csrf_token" value="<?php echo generate_csrf_token(); ?>">

        
        <label for="username">Username:</label>
        <input type="text" name="username" >

        <label for="email">Email:</label>
        <input type="email" name="email" >

        
        <label for="password">Password:</label>
        <input type="password" name="password" >

        <label for="confirm_password">Confirm Password:</label>
        <input type="password" name="confirm_password" >

        <button type="submit">Register</button>
    </form>
</body>
</html>


<?php

$users = [];

function generate_csrf_token() {
    return bin2hex(random_bytes(32));
}

function validate_csrf_token($token) {
    return isset($_SESSION['csrf_token']) && hash_equals($_SESSION['csrf_token'], $token);
}

session_start();

if ($_SERVER['REQUEST_METHOD'] === 'POST') {

    $csrf_token = $_POST['csrf_token'];
    if (!validate_csrf_token($csrf_token)) {
        die("CSRF token validation failed.");
    }

    
    $username = $_POST['username'];
    $email = $_POST['email'];
    $password = $_POST['password'];
    $confirm_password = $_POST['confirm_password'];

    
    if (empty($username) || empty($email) || empty($password) || empty($confirm_password) || !filter_var($email, FILTER_VALIDATE_EMAIL) || $password !== $confirm_password) {
        die("Validation failed. Please fill in all required fields, use a valid email, and ensure passwords match.");
    }

    
    if (strlen($password) < 8 || !preg_match("/[A-Z]+/", $password) || !preg_match("/[a-z]+/", $password) || !preg_match("/[0-9]+/", $password)) {
        die("Password should be at least 8 characters long and include uppercase, lowercase, and numeric characters.");
    }

    
    $hashed_password = password_hash($password, PASSWORD_BCRYPT);

    $users[$email] = [
        'username' => $username,
        'email' => $email,
        'hashed_password' => $hashed_password,
    ];

    echo "Registration successful!";
} else {
    echo "Access denied. Please submit the form.";
}

?>
