<?php
$uploadDir = "uploads/";

// File Upload Handling
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_FILES['file'])) {
        $file = $_FILES['file'];

        $fileName = $file['name'];
        $fileTmpName = $file['tmp_name'];
        $fileSize = $file['size'];
        $fileError = $file['error'];
        $fileType = $file['type'];

        $allowedExtensions = array("txt", "csv", "pdf", "jpg", "jpeg", "png");
        $maxFileSize = 5242880; // 5 MB

        $fileExtension = pathinfo($fileName, PATHINFO_EXTENSION);

        if (!in_array(strtolower($fileExtension), $allowedExtensions)) {
            echo "Error: Unsupported file type.";
            exit();
        }

        if ($fileSize > $maxFileSize) {
            echo "Error: File size exceeds the limit.";
            exit();
        }

        $destination = $uploadDir . $fileName;
        move_uploaded_file($fileTmpName, $destination);
        echo "File uploaded successfully!";
    }
}

$files = array_diff(scandir($uploadDir), array('..', '.'));

if (isset($_GET['read'])) {
    $selectedFile = $_GET['read'];
    $filePath = $uploadDir . $selectedFile;

    if (file_exists($filePath)) {
        $fileContent = file_get_contents($filePath);
        echo "<h2>File Content: $selectedFile</h2>";
        echo "<pre>$fileContent</pre>";
    } else {
        echo "File not found.";
    }
}

// Write to CSV File
if (isset($_POST['content']) && isset($_POST['write'])) {
    $content = $_POST['content'];
    $csvContent = explode("\n", $content);

    $csvFilePath = $uploadDir . "example.csv";
    file_put_contents($csvFilePath, implode("\n", $csvContent));

    echo "CSV file written successfully!";
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>File Management</title>
</head>
<body>
    <h2>File Upload</h2>
    <form action="" method="post" enctype="multipart/form-data">
        <label for="file">Choose a file:</label>
        <input type="file" name="file" id="file" required>
        <button type="submit" name="submit">Upload</button>
    </form>

    <h2>File Listing</h2>
    <ul>
        <?php
        foreach ($files as $file) {
            echo "<li><a href='?read=$file'>$file</a> - <a href='?download=$file'>Download</a></li>";
        }
        ?>
    </ul>

    <h2>Read and Write Files</h2>
    <?php
    if (isset($_GET['read'])) {
        echo "<form action='' method='post'>";
        echo "<textarea name='content' rows='10' cols='30'>$fileContent</textarea><br>";
        echo "<button type='submit' name='write'>Write to CSV</button>";
        echo "</form>";
    }
    ?>

    <h2>File Download</h2>
    <?php
    if (isset($_GET['download'])) {
        $fileToDownload = $_GET['download'];
        $downloadLink = $uploadDir . $fileToDownload;

        if (file_exists($downloadLink)) {
            echo "<p><a href='$downloadLink' download>Download $fileToDownload</a></p>";
        } else {
            echo "File not found.";
        }
    }
    ?>
</body>
</html>
